<?php

/*
 * Plugin name: Displet RETS/IDX
 * Plugin URI: http://displet.com/wordpress-plugins/displetreader-wordpress-plugin
 * Description: RETS/IDX Plugin that inserts real estate listings, statistics, maps, and quick searches into Wordpress pages & widget ready sidebars. Free version available.
 * Version: 2.0.8
 * Author: Displet
 * Author URI: http://displet.com/
 * License: GPL2
 */

/*  Copyright 2011 Displet (email : dev@displet.com)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License, version 2, as 
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

abstract class DispletRetsIdxPlugin{
	protected static $plugin_version = '2.0.8';
	protected static $api_url = 'http://api.displet.com';

    public function add_version(){
        echo '<!-- Displet RETS/IDX v. ' . self::$plugin_version . ' -->';
    }

    public function notifications(){
    	$last_version = DispletRetsIdxSettings::get_option('version');
    	// If plugin was just updated
    	if (version_compare(self::$plugin_version, $last_version)) {
    		$model = array();
    		echo DispletRetsIdxLoad::get_admin_template('api-token-notification-jquery.php', $model);
        }
        // If previous plugin version before 2.0.7
        /*
        if (version_compare('2.0.7', $last_version)) {

        }
        */
    }
}

add_action('wp_head', array('DispletRetsIdxPlugin', 'add_version'), 1000000);
add_action('admin_head', array('DispletRetsIdxPlugin', 'notifications'));
register_activation_hook(__FILE__, array('DispletRetsIdxSettings', 'register_default_settings'));
register_activation_hook(__FILE__, array('DispletRetsIdxSearchFormWidgets', 'register_default_widgets'));
register_activation_hook(__FILE__, array('DispletRetsIdxSearchFormWidgets', 'register_default_widget_areas_content'));
register_activation_hook(__FILE__, array('DispletRetsIdxUrlStructure', 'reset_flush_rewrite_check'));
register_activation_hook(__FILE__, array('DispletRetsIdxEmails', 'adjust_activity_report_schedule'));
register_deactivation_hook(__FILE__, array('DispletRetsIdxEmails', 'unschedule_activity_report'));

require_once('displet-emails.php');
require_once('displet-email-templates.php');
require_once('displet-google-login.php');
require_once('displet-load.php');
require_once('displet-mobile.php');
require_once('includes/displet-mobile-detect.php');
require_once('displet-model.php');
require_once('displet-query.php');
require_once('displet-quick-start.php');
require_once('displet-property-details.php');
require_once('displet-search-results.php');
require_once('displet-search-form-widgets.php');
require_once('displet-shortcodes.php');
require_once('displet-tinymce.php');
require_once('displet-settings.php');
require_once('displet-url-structure.php');
require_once('displet-users.php');
require_once('displet-utilities.php');
require_once('displet-widgets.php');

?>