<?php

class DispletRetsIdxListings{
	function render_shortcode($attributes){
		// Retrieve options from settings page
		global $displetretsidx_option;
		global $displetretsidx_model;
	
		// Create list of acceptable attributes (array keys) and a $model['key'] from each array key, using the shortcode attribute as the value when specified, else the setting default or other specification in array
		$model = shortcode_atts(array(
			// Has settings defaults but shortcode override
			'price_navigation' => stripslashes($displetretsidx_option['include_price_navigation']),
			'property_type_navigation' => stripslashes($displetretsidx_option['include_property_type_navigation']),
			'property_type_sorting' => stripslashes($displetretsidx_option['include_property_type_sorting']),
			'stats' => stripslashes($displetretsidx_option['include_stats']),
			// Has only shortcode attributes
			'listings' => '',
			'caption' => '',
			'minlistprice' => '',
			'maxlistprice' => '',
			'minbedrooms' => '',
			'maxbedrooms' => '',
			'minbathrooms' => '',
			'maxbathrooms' => '',
			'minsquarefeet' => '',
			'maxsquarefeet' => '',
			'quick_terms' => '',
			'area_mls_defined' => '',
			'city' => '',
			'property_type' => '',
			'minstories' => '',
			'waterfront' => '',
			'pool_on_property' => '', 
			'subdivision' => '',
			'keyword' => '',
			'school' => '',
			'school_district' => '',
			'minacres' => '',
			'zip' => '',
			'is_foreclosure' => '',
			'yearbuilt' => '',
			'county' => '',
			'status' => '',
			'short_sale' => '',
			'last_modified' => '',
			'listing_agent_id' => '',
			'listing_office_id' => '',
			'min_lot_size' => '',
			'is_gated_community' => '',
			'min_sold_date' => '',
			'max_sold_date' => '',
			'master_on_main' => '',
			'basement' => '',
			'min_square_feet_available' => '',
			'max_square_feet_available' => '',
			'min_price_per_sq_feet' => '',
			'max_price_per_sq_feet' => '',
			'street_name' => '',
			'street_number' => ''
		), $attributes);
		$model['show_listings'] = $model['listings'];
		$model['listings'] = false;

		$model = array_merge($model, $displetretsidx_model);
		$model['return_fields'] = DispletRetsIdxQuery::get_return_fields($model['options']);
		$model['query_url'] = DispletRetsIdxQuery::get_query_url($model);
	
		// Get current page and create previous/next links, update start number if paginated
		$page_id = intval(get_query_var('paged'));
		$page_url = rtrim(get_permalink(), '/');
		if ($page_id) {
			$next_page_id = $page_id + 1;
			$previous_page_id = $page_id - 1;
			if ($page_id < 2) {
				$previous_page = '/#previous';
			}
			else{
				$previous_page = '/page/' . $previous_page_id;
			}
			//$next_listing_count = $page_id * $model['listings_per_page'] + 1;
			//if (!empty($model['options']['results_limit']) && $next_listing_count > intval($model['options']['results_limit'])) {
			//	$next_page = '/#next';
			//}
			//else{
				$next_page = '/page/' . $next_page_id;
			//}
			$model['previous_page_url'] = $page_url . $previous_page;
			$model['next_page_url'] = $page_url . $next_page;
			if ($page_id > 1) {
				if ($model['is_displet_api']) {
					$new_start = '&page=' . $page_id;
					$model['query_url'] = str_replace('&page=1', $new_start, $model['query_url']);
				}
				else{
					$start_id = ($page_id - 1) * $model['listings_per_page'] + 1;
					$new_start = '&start=' . $start_id;
					$model['query_url'] = str_replace('&start=1', $new_start, $model['query_url']);
				}
			}
		}
		else{
			$model['previous_page_url'] = $page_url . '/#previous';
			$model['next_page_url'] = $page_url . '/page/2';
		}
	
		// Get listings server-side to pass to templates for crawlable content
		$listings = DispletRetsIdxQuery::get_listings($model);
		$model = array_merge($model, $listings);

		// Determine Property Type navigation/sorting
		if (((!empty($model['property_type_navigation']) && strtolower($model['property_type_navigation']) != 'no') || (!empty($model['property_type_sorting']) && strtolower($model['property_type_sorting']) != 'no')) && strtolower($model['show_listings']) != 'no' && intval($model['meta']->count) > 9) {
			$property_types = self::get_property_type_navigation($model);
			$model['property_types'] = $property_types;
		}

		// Determine sorting options
		$model['sort_options'] = self::get_sort_options($model);

		// Detertimine if max results message is needed
		if (intval($model['meta']->count) > intval($model['options']['results_limit'])) {
			$model['results_limit_message'] = self::get_max_results_message($model['options']);
		}

		// Grab appropriate templates
		$displet_templates = '';
		if (!empty($model['caption'])) {
			$displet_templates .= '<h2 class="displet-caption">' . $model['caption'] . '</h2>';	
		}
		if (intval($model['meta']->count) > 0) {
			$displet_templates .= DispletRetsIdxLoad::get_template('displet-listings-jquery.php', $model);
			if ($model['is_displet_api']) {
				if (!empty($model['property_type_navigation']) && strtolower($model['property_type_navigation']) != 'no' && strtolower($model['show_listings']) != 'no' && intval($model['meta']->count) > 9) {
					$displet_templates .= DispletRetsIdxLoad::get_template('displet-property-type-navigation.php', $model);
				}
				if (!empty($model['price_navigation']) && strtolower($model['price_navigation']) != 'no' && strtolower($model['show_listings']) != 'no' && intval($model['meta']->count) > 9) {
					$displet_templates .= DispletRetsIdxLoad::get_template('displet-price-navigation.php', $model);
				}
				if (!empty($model['stats']) && strtolower($model['stats']) != 'no') {
					$displet_templates .= DispletRetsIdxLoad::get_template('displet-statistics.php', $model);
				}
			}
		}
		else if (!empty($model['show_listings']) && strtolower($model['show_listings']) == 'no' && !empty($model['stats']) && strtolower($model['stats']) != 'no') {
			$displet_templates .= DispletRetsIdxLoad::get_template('displet-statistics.php', $model);
		}
		if (strtolower($model['show_listings']) != 'no') {
			$displet_templates .= DispletRetsIdxLoad::get_template('displet-dynamic.php', $model);
		}
	
		return $displet_templates;
	}

	public function render_shortcode_stats(){
		// Empty to remove legacy shortcode calls
	}

	public function get_disclaimer($model){
		$disclaimer = '';
		if (!empty($model['options']['disclaimer_image'])) {
			$disclaimer .= '<img class="displet-mls-logo" src="' . $model['options']['disclaimer_image'] . '" />';
		}
		if (!empty($model['options']['disclaimer'])) {
			$disclaimer .= str_replace('%%date_last_updated%%', $model['last_updated'], $model['options']['disclaimer']);
		}
		return $disclaimer;
	}

	public function get_max_results_message($options){
		if (!empty($options['results_limit'])) {
			return 'Only ' . $options['results_limit'] . ' properties may be displayed per search. To see all results, please narrow your search criteria.';
		}
		return false;
	}

	public function get_property_type_navigation($model){
		$property_types = array();
		if (!empty($model['property_type'])){
			$model_property_types = explode(',', $model['property_type']);
			foreach ($model_property_types as $property_type) {
				$key = strtolower(trim($property_type));
				$property_types[$key] = $property_type;
			}
		}
		else{
			$displetretsidx_field_option = DispletRetsIdxSettings::get_option('fields');
			foreach ($displetretsidx_field_option['property_type'] as $property_type) {
				$key = strtolower($property_type);
				$property_types[$key] = $property_type;
			}
		}
		$filter_used = false;
		if (!empty($model['options']['property_type_include_filter'])) {
			foreach ($model['options']['property_type_include_filter'] as $key => $value) {
				$new_key = strtolower($key);
				$filter_property_types[$new_key] = $value;
				if ($value != 'false') {
					$filter_used = true;
				}
			}
		}
		if (!empty($property_types) && !empty($filter_used)) {
			foreach ($property_types as $property_type_key => $value) {
				if (isset($filter_property_types[$property_type_key]) && $filter_property_types[$property_type_key] == 'false'){
					unset($property_types[$property_type_key]);
				}
			}
		}
		return $property_types;
	}

	public function get_sort_options($model){
		$sort_options =
			'<option class="displet-font-color-light" value="">Sort By</option>
			<option class="displet-font-color-light" value="price-ascending">Price Low to High</option>
			<option class="displet-font-color-light" value="price-descending">Price High to Low</option>';
		if (!$model['is_displet_api']) {
			$sort_options .=
				'<option class="displet-font-color-light" value="date-descending">Newest</option>
				<option class="displet-font-color-light" value="date-ascending">Oldest</option>';
		}
		else if (((!empty($model['property_type_sorting']) && strtolower($model['property_type_sorting']) != 'no' && strtolower($model['show_listings']) != 'no') || (empty($model['property_type_sorting']) && !empty($model['options']['include_property_type_sorting']))) && intval($model['meta']->count) > 9) {
			$sort_options .= '<option class="displet-font-color-light" value="all">All Property Types</option>';
			foreach ($model['property_types'] as $key => $value) {
				$sort_options .= '<option class="displet-font-color-light" value="' . $key . '">' . $value . '</option>';
			}
		}
		return $sort_options;
	}
	
	function update_canonical(){
		// Determine if page contains DispletListing shortcode
		$shortcode = false;
		$regex = '/' . get_shortcode_regex() . '/s';
		global $posts;
		if (isset($posts[0])) {
			preg_match($regex, $posts[0]->post_content, $matches);
			if (is_array($matches) && isset($matches[2]) && $matches[2] == 'DispletListing') {
				$shortcode = true;
			}
		}
		// Remove default canonical and add ours
		if (get_query_var('paged') && $shortcode){
			remove_action('wp_head', 'rel_canonical');
			add_action('wp_head', array('DispletRetsIdxListings', 'add_canonical'), 1);
		}
	}

	function add_canonical(){
		// Add canonical that includes /page/id
		$link = rtrim(get_permalink(), '/');
		$paged = get_query_var('paged');
		if ($paged) {
			$link .= '/page/' . $paged;
		}
	    echo '<link rel="canonical" href="' . esc_url($link) . '" />';
	}

	function remove_yoasts_canonical($canonical) {
		// Determine if page contains DispletListing shortcode
		$shortcode = false;
		$regex = '/' . get_shortcode_regex() . '/s';
		global $posts;
		if (isset($posts[0])) {
			preg_match($regex, $posts[0]->post_content, $matches);
			if (is_array($matches) && isset($matches[2]) && $matches[2] == 'DispletListing') {
				$shortcode = true;
			}
		}
		if (get_query_var('paged') && $shortcode) {
	    	$canonical = false;
	    }
		return $canonical;
	}
}

add_shortcode('DispletListing', array('DispletRetsIdxListings', 'render_shortcode'));
add_shortcode('DispletStats', array('DispletRetsIdxListings', 'render_shortcode_stats'));
add_action('template_redirect', array('DispletRetsIdxListings', 'update_canonical'));
add_filter('wpseo_canonical', array('DispletRetsIdxListings', 'remove_yoasts_canonical'));

?>