<?php
	/***************************
	Available Variables:
	$model['options'] = array(); // All fields from settings/settings-page.php
	$model = array(
		'is_displet_api',
		'query_url'
	);
	$model['meta'] = array(
		'first',
		'last',
		'count',
		'limit',
		'page',
		'list_price_min',
		'list_price_max',
		'list_price_mean',
		'square_feet_min',
		'square_feet_max',
		'square_feet_mean'
	);
	$model['listings'][$i] = array(
		'address',
		'bathrooms',
		'city',
		'full_baths',
		'half_baths',
		'id',
		'image_urls',
		'internet_remarks',
		'latitude',
		'listing_office_name',
		'longitude',
		'mls_number',
		'num_bedrooms',
		'permalink',
		'property_type',
		'square_feet',
		'street_name',
		'street_number',
		'street_post_dir',
		'state',
		'subdivision',
		'zip'
	);
	***************************/
	// Echo query URL
	echo '<!-- Displet Query: ' . $model['query_url'] . ' -->';
?>
<div id="displet-sidescroller-widget" class="displet-default-styles displet-listings-carousel">
	<?php if (isset($model['listings']) && count($model['listings'] > 0)) : ?>
		<ul>
		<?php
			$i = 1;
			foreach ($model['listings'] as $listing) :
		?>
			<li><a class="displet-sidescroller-widget-listing displet-listing-<?php echo $i; ?>" href="<?php echo $listing->permalink; ?>">
				<div class="displet-sidescroller-widget-thumb-container"<?php if ($listing->image_urls->primary_big) echo ' style="background-image:url(' . "'" . $listing->image_urls->primary_big . "'" . ');"'; ?>>
					<img class="displet-image-value"<?php if ($listing->image_urls->primary_big) echo ' src=' . $listing->image_urls->primary_big; ?> />
				</div>
				<div class="displet-sidescroller-widget-price-container">
					<span class="displet-dollar">$</span>
					<span class="displet-sidescroller-widget-listing-price displet-price-value">
						<?php echo number_format($listing->list_price); ?>
					</span>
					<div class="displet-clear"><!-- --></div>
				</div>
				<div class="displet-sidescroller-widget-info">
					<div class="displet-sidescroller-widget-address">
						<div class="displet-street-address displet-address-value">
							<?php echo $listing->address; ?>
						</div>
						<div class="displet-city-state-zip">
							<span class="displet-city-value"><?php echo $listing->city; ?></span>,
							<span class="displet-state-value"><?php echo $listing->state; ?></span>
							<span class="displet-zip-value"><?php echo $listing->zip; ?></span>
						</div>
						<?php if (!empty($listing->subdivision)) : ?>
							<div class="displet-subdivision displet-subdivision-value displet-font-color-light">
								<?php echo $listing->subdivision; ?>
							</div>
						<?php endif; ?>
					</div>
					<div class="displet-sidescroller-widget-specs">
						<?php if (!empty($listing->num_bedrooms) || !empty($listing->bathrooms)) : ?>
							<div class="displet-beds-baths">
								<?php if (!empty($listing->num_bedrooms)) : ?>
									<span class="displet-beds displet-beds-value">
										<?php echo $listing->num_bedrooms; ?>
									</span>
									Bed
								<?php endif; ?>
								<?php if (!empty($listing->num_bedrooms) && !empty($listing->bathrooms)) : ?>
									/
								<?php endif; ?>
								<?php if (!empty($listing->bathrooms)) : ?>
									<span class="displet-full-baths displet-baths-value">
										<?php echo $listing->bathrooms; ?>
									</span>
									Bath
								<?php endif; ?>
							</div>
						<?php endif; ?>
						<?php if (!empty($listing->square_feet)) : ?>
							<div class="displet-square-feet">
								<span class="displet-square-feet-value"><?php echo number_format($listing->square_feet); ?></span>
								Sq. Ft.
							</div>
						<?php endif; ?>
						<?php if (!empty($listing->property_type)) : ?>
							<div class="displet-property-type">
								Property Type:
								<span class="displet-property-type-value"><?php $property_type = str_replace('Houses', 'House', $listing->property_type); echo str_replace('Condos, Townhouses & Apts for Sale', 'Condo / Townhouse / Apt', $property_type); ?></span>
							</div>
						<?php endif; ?>
						<?php if (!empty($listing->mls_number)) : ?>
							<div class="displet-mls displet-font-color-light">
								MLS&reg; #:
								<span class="displet-mls-value displet-font-color-light">
									<?php echo $listing->mls_number; ?>
								</span>
							</div>
						<?php endif; ?>
						<?php if (!empty($listing->listing_agent_name) || !empty($listing->listing_office_name)) : ?>
							<div class="displet-courtesy displet-font-color-light">
								Courtesy of
								<span class="displet-listing-agent-name-value displet-font-color-light">
									<?php
										if (!empty($listing->listing_agent_name) && !empty($listing->listing_office_name)) $listing->listing_agent_name .= ',';
										echo $listing->listing_agent_name;
									?>
								</span>
								<span class="displet-listing-office-name-value displet-font-color-light">
									<?php echo $listing->listing_office_name; ?>
								</span>
							</div>
						<?php endif; ?>
						<?php if (!empty($model['options']['disclaimer_image']) && !empty($model['options']['include_disclaimer_image'])) : ?>
							<img class="displet-mls-logo" src="<?php echo $model['options']['disclaimer_image']; ?>" />
						<?php endif; ?>
					</div>
				</div>
				<div class="displet-view-details">
					View Details
				</div>
			</a></li>
		<?php $i++; endforeach; ?>
		</ul>
		<div class="displet-navigation">
			<div class="displet-navigation-inner">	
				<a class="displet-navigation-previous">
					Previous
				</a>
				<a class="displet-navigation-next">
					Next
				</a>
			</div>
		</div>
	<?php else : ?>
		<div class="displet-sidescroller-widget-no-results"><span>No listings available</span></div>
	<?php endif ?>
</div>